%define RELEASE		2314
%define VERSION		1.0
%define TARNAME		NVIDIA_kernel
%define rel		alt4
%define ver     	%VERSION.%RELEASE


# Define kunamever to build for another kernel
%if %{!?kunamever: 1}0
%define kunamever %(uname -r)
%endif

%define kver		%(echo "%kunamever"| awk -F'-' '{print $1}')
%define kbuild		%(echo "%kunamever"| awk -F'-' '{print $2}')
%define kncpu		%(echo "%kunamever"| awk -F'-' '{print $3}')
%define kpkgprfx	%(if echo "%kver"| grep '2.4.'>/dev/null; then echo "24"; else echo "22"; fi)
%define not_junior	%(if grep -v Junior /etc/altlinux-release >/dev/null; then echo "1"; fi)

Version: %ver
Release: %rel
Name: kernel-nvidia

%define unseen_field YOU SHOULD NEVER SEE THIS
Summary: %unseen_field
License: %unseen_field
Group: %unseen_field

Source: ftp://ftp1.detonator.nvidia.com/pub/drivers/english/XFree86_40/%TARNAME-%VERSION-%RELEASE.tar.gz
NoSource: 0

# A script that tries to build this pkg for all installed kernels
Source1: build_for_all_kernels

Url: http://www.nvidia.com
Vendor: NVIDIA Corp.

BuildPreReq: cpp gcc rpm >= 3.0.4
BuildPreReq: kernel%kpkgprfx-headers = %kver-%kbuild
BuildPreReq: kernel%kpkgprfx-%kncpu = %kver-%kbuild

%define binPkgName kernel%{kpkgprfx}_%{kncpu}_%{kver}_%{kbuild}-nvidia
%package -n %binPkgName
Group: System/Kernel and hardware
Summary: NVIDIA kernel module for NVIDIA Architecture support
License: NVIDIA Corp. 2000

Provides: %name = %version-%release

Requires: kernel%kpkgprfx-%kncpu = %kver-%kbuild
Requires: rpm >= 3.0.4

%description
%unseen_field

%description -n %binPkgName
NVIDIA Architecture support for Linux kernel 2.2.X and 2.4.X

%prep
%setup -q -n %TARNAME-%VERSION-%RELEASE

%build
%__ln_s /usr/lib/kernel/%kunamever linux
%make NVdriver CC="gcc-2.96 $RPM_OPT_FLAGS" IGNORE_CC_MISMATCH=yes \
    EXTRA_DEFINES=-DMODVERSIONS \
    SYSINCLUDE="/usr/lib/kernel/%kver-%kbuild/include"


%install
    rm -f /tmp/files.lst

    if [ -z "$TOWHAT_KERNEL" ]; then
        export TOWHAT_KERNEL=%kunamever
    fi

    if [ -d $RPM_ROOT/lib/modules/$TOWHAT_KERNEL/kernel ]; then
        INSTALLPATH=/lib/modules/$TOWHAT_KERNEL/kernel/drivers/video
    else
        INSTALLPATH=/lib/modules/$TOWHAT_KERNEL/video
    fi
    mkdir -p $RPM_BUILD_ROOT/$INSTALLPATH
    install -m 0444 NVdriver $RPM_BUILD_ROOT/$INSTALLPATH
    echo "%attr(444 root root) " $INSTALLPATH/NVdriver > /tmp/files.lst

    #    unset RPM_BUILD_ROOT  # trick RPM 4.0 into not stripping us
    %set_strip_method none


%post -n %binPkgName
    /sbin/rmmod NVdriver >/dev/null 2>&1

    confmod="/etc/conf.modules"
    [ -f /etc/modules.conf ] && confmod="/etc/modules.conf"
    conftmp=/tmp/conf$$

    sed '/^alias.*char-major-.*NVdriver/d' < $confmod > $conftmp
    echo "alias char-major-195 NVdriver" >> $conftmp
    mv $conftmp $confmod

    /sbin/depmod -a
    exit 0

%preun -n %binPkgName
if [ $1 = 0 ] ; then
    if [ -n "`/sbin/lsmod | grep NVdriver`" ]; then
        /sbin/rmmod NVdriver
    fi
fi

%files -n %binPkgName -f /tmp/files.lst

%changelog
* Thu Jan 31 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.2314-alt4
- fix %%provides, %%files
  thanx Andrey S Pankov <alt-bugs@casper.org.ua>

* Tue Jan 29 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.2314-alt3
- removed /dev/* form %%files
- cleanup spec

* Wed Dec 25 2001 Ivan Zakharyaschev <imz@altlinux.ru>  1.0.2314-alt2
- include kernel version information in the name of the binary pkg and
  provide a virtual pkg "kernel-nvidia"
- goldhead's "MODVERSIONS" patch obsoleted by make's argument
- allow build for any installed kernel with headers
- set IGNORE_CC_MISMATCH 
  and use gcc-2.96 explicitly not to depend from gcc set by update-alternatives
- own ghost device nodes
- added a script for building the kernel for all installed kernels

* Fri Dec 14 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.0.2314-alt1
- 1.0.2314
- Fixed CFLAGS

* Wed Dec 05 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.2313-alt1
- new version

* Wed Sep 19 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1512-alt8
- fix build with -DMODVERSIONS

* Tue Sep 11 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1512-alt7
- first build
# Local variables:
# compile-command: "rpmbuild -ba --target=i586 kernel-nvidia-1.0.2314.my.spec"
# End:
